import { EditorStateConfig, EditorState } from '@codemirror/state';
import { EditorView, ViewUpdate, EditorViewConfig } from '@codemirror/view';

declare const EditorTools: (view: EditorView) => {
    getDoc: () => string;
    setDoc: (newDoc: string) => void;
    focus: () => void;
};

interface CreateStateOptions extends EditorStateConfig {
    onChange(doc: string, viewUpdate: ViewUpdate): void;
    onUpdate(viewUpdate: ViewUpdate): void;
    onFocus(viewUpdate: ViewUpdate): void;
    onBlur(viewUpdate: ViewUpdate): void;
}
declare const createEditorState: ({ onUpdate, onChange, onFocus, onBlur, ...config }: CreateStateOptions) => EditorState;
/**
 *
 * @param config
 * @returns
 */
declare const createEditorView: (config: EditorViewConfig) => EditorView;
/**
 * Destroy EdiorView.
 *
 * @param view
 * @returns
 */
declare const destroyEditorView: (view: EditorView) => void;

export { CreateStateOptions, EditorTools, createEditorState, createEditorView, destroyEditorView };
